/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test7.c -o outputname -Wall 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary


// function prototypes  -with or without arg names
int myownprint( double ); 
int change( double *, int, double );
int change2( double *, double );


int main(  )
{
  // #7 function arguments 
  
  int i;
  double vec[10] = {10.01, 0.111, 1.221, 3.331, -4.004, -5544, .6666, 7001, 8000, -9090};

  printf(" { ");
  for( i=0; i<10; i++ )
    printf("%g ", vec[i] );
  printf("}\n");


  // argument passed by value
  myownprint( vec[3] );  
  // myownprint cannot modify vec[3], but only use it


  
   // In order for a function to modify the value of its arguments, 
   // these have to be passed by reference, i.e. the function needs to 
   // know their physical address.

   // argument is passed by reference 
   // &vec[0] (or vec) is the address of the vector vec

  
  change( vec, 3, 33.3 );
  change( &vec[3], 1, 33.3 );
  
  printf(" { ");
  for( i=0; i<10; i++ )
    printf("%g ", vec[i] );
  printf("}\n");



  //{10.01, 0.111, 1.221, 3.331, -4.004, -5544, .6666, 7001, 8000, -9090};




  //is the second argument of change necessary?
  //would this work?
  //  change( &vec[3], 0, 33.3 );



  
  change2( &vec[9], 4.4 );

  printf(" { ");
  for( i=0; i<10; i++ )
    printf("%g ", vec[i] );
  printf("}\n");
  


  /*
   // pay attention to the definitions of myownprint and change:
   // myownprint ( double )       <- value
   // change( double *,  ... )    <- pointer (i.e., address, reference)
   */

  
  return( 0 );
}



// function definitions

int  myownprint( double number )
{
   int i;

   for( i=1; i<=4; i++ )
      printf(" Function  myownprint  :  *** %.*g *** \n", i, number );

   return( 0 );
}


int change( double *v, int idx, double val )
{
   v[idx] = val;

   return( 0 );
}


int change2( double *v, double val )
{
   *v = val;
   //v[2] = val;
   
   return( 0 );
}



